/*====================================================================
| Version: November 11, 2010
\===================================================================*/

/*====================================================================
| Ricard Delgado-Gonzalo
| EPFL/STI/IOA/LIB/BM.4.141
| e-mail: ricard.delgado@gmail.com
| URL: http://www.ricarddelgado.com/
\===================================================================*/
package filters;

public class CTBinaryDilation {
	
	static public boolean[] binaryDilation(boolean[] map, int width, int height){
		boolean[] dilatedMap = new boolean[map.length];
			
		for(int i=0; i<map.length; i++){
			dilatedMap[i] = false;
		}
		
		for(int i=0; i<width; i++){
			for(int j=0; j<height; j++){
				if(map[i+width*j]){
					dilatedMap[i+width*j] = true;
					if(i-1>=0) dilatedMap[i-1+width*j] = true;
					if(j-1>=0) dilatedMap[i+width*(j-1)] = true;
					if(i+1<width) dilatedMap[i+1+width*j] = true;
					if(j+1<height) dilatedMap[i+width*(j+1)] = true;
				}
			}
		}
		return dilatedMap;
	}
}
